<%-- calendarview include content tag --%>
<%@ tag pageEncoding="UTF-8" body-content="empty"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ taglib uri="http://www.jasminesoft.co.jp/jfc" prefix="jfc" %>
<%@ taglib tagdir="/WEB-INF/tags" prefix="tags" %>
<fmt:setBundle basename="jfcapp"/>

<%@ attribute name="modelId" required="true" %>
<%@ attribute name="jfcCalendarColumnViewMinHours" %>
<%@ attribute name="jfcCalendarColumnViewMaxHours" %>
<%@ attribute name="__jfc_calendarFirstDayOfWeek" %>

<c:set var="jfcCalendarFirstDayOfWeek" value="0"/>
<c:if test="${fn:length(__jfc_calendarFirstDayOfWeek) > 0}"><c:set var="jfcCalendarFirstDayOfWeek" value="${__jfc_calendarFirstDayOfWeek}"/></c:if>
<c:set var="jfcCalendarMinHours" value="8"/>
<c:if test="${fn:length(jfcCalendarColumnViewMinHours) > 0}"><c:set var="jfcCalendarMinHours" value="${jfcCalendarColumnViewMinHours}"/></c:if>
<c:set var="jfcCalendarMaxHours" value="24"/>
<c:if test="${fn:length(jfcCalendarColumnViewMaxHours) > 0}"><c:set var="jfcCalendarMaxHours" value="${jfcCalendarColumnViewMaxHours}"/></c:if>

<div id="jfcModernCalendar"></div>

<div data-dojo-id="jfcCalendarItemDialog" id="jfcCalendarItemDialog" data-dojo-type="dojox/mobile/Tooltip" style="width:300px;height:300px;">
</div>

<div id="jfcRegisterCalendarItemOverlay" data-dojo-type="dojox/mobile/Overlay" style="height:300px;">
<h1 data-dojo-type="dojox/mobile/Heading">新規登録</h1>
<form data-dojo-type="dijit/form/Form" data-dojo-id="jfcRegisterMobileCalendarItemForm" id="jfcRegisterMobileCalendarItemForm" action="" method="post" style="padding-bottom: 0;">
<table class="display_table">
<tbody id="jfcCalendarItemDialogTableTbody">
<tr class="display_field"><th class="display_label">モデル名</th><td><select data-dojo-type="dijit/form/Select" id="lbxJfcRegisterMobileCalendarViewModel" data-dojo-id="lbxJfcRegisterMobileCalendarViewModel" name="modelId" style="width: 150px;"></select></td></tr>
<tr class="display_field"><th class="display_label">タイトル</th><td><input type="text" data-dojo-type="dijit/form/TextBox" data-dojo-id="jfcRegisterMobileCalendarItemSummary" name="summary" data-dojo-props="required: true, selectOnClick: true" style="width: 99%;"/></td></tr>
<tr class="display_field"><th class="display_label">開始日時</th><td>
<input type="text" data-dojo-type="wagby/DateTextBox" data-dojo-id="jfcRegisterMobileCalendarItemStartDate" name="startDate" data-dojo-props="dateFormat: 'yyyy-MM-dd', required: true" style="width: 150px;"/>
<input type="text" data-dojo-type="dijit/form/TimeTextBox" data-dojo-id="jfcRegisterMobileCalendarItemStartTime" name="startTime"/></td></tr>
<tr class="display_field"><th class="display_label">終了日時</th><td>
<input type="text" data-dojo-type="wagby/DateTextBox" data-dojo-id="jfcRegisterMobileCalendarItemEndDate" name="endDate" data-dojo-props="dateFormat: 'yyyy-MM-dd', required: true" style="width: 150px;"/>
<input type="text" data-dojo-type="dijit/form/TimeTextBox" data-dojo-id="jfcRegisterMobileCalendarItemEndTime" name="endTime"/></td></tr>
<tr class="display_field"><th class="display_label">終日</th><td>
<input type="checkbox" data-dojo-type="dijit/form/CheckBox" data-dojo-id="jfcRegisterMobileCalendarItemAllDay" id="jfcRegisterMobileCalendarItemAllDay" name="allDay"/></td></tr>
<tr class="display_field">
<td colspan="2">
<div class="buttonGroup">
<button data-dojo-type="dojox/mobile/Button" data-dojo-id="btnInsertJfcRegisterMobileCalendarItem" type="button"></button>
<button data-dojo-type="dojox/mobile/Button" data-dojo-id="btnCancelJfcRegisterMobileCalendarItem" type="button" data-dojo-props="onClick: function() { dijit.registry.byId('jfcRegisterCalendarItemOverlay').hide(); }"></button>
</div>
</td>
</tr>
<input data-dojo-type="dijit/form/TextBox" type="hidden" data-dojo-id="jfcRegisterMobileCalendarItemId" name="jfcRegisterMobileCalendarItemId">
</form>
</div>

<script type="text/javascript">
require(["dijit/Calendar", "dijit/form/Form", "dijit/registry", "dojo/_base/array", "dojo/_base/connect", "dojo/dom-construct", "dojo/dom-prop", "dojo/dom-style", "dojo/on", "dojo/query", "dojo/window", "dojo/ready"],
function(Calendar, Form, registry, array, connect, domConstruct, domProp, domStyle, on, query, win, ready) {
  ready(function() {
    // JSP の画面メッセージを非表示にして、メッセージをポップアップで表示する
    disableJspMessageAndBubble();

    var calendarOption = {
      id: "jfcModernCalendar",
      modelId: "${modelId}",
      minHours: ${jfcCalendarMinHours},
      maxHours: ${jfcCalendarMaxHours},
      firstDayOfWeek: ${jfcCalendarFirstDayOfWeek},
      dateInterval: "week",
      isMobile: true,
    };

    // カレンダの生成
    var calendar = ModernCalendarUtil.createCalendar(calendarOption);
    // カレンダの設定
    setCalendarViewProperty(calendar, "${modelId}");
    // カレンダビューのイベントを設定する
    setCalendarviewEvent(calendar);
    // 新規登録ダイアログの設定
    setRegisterCalendarItemOverlay(calendarOption, calendar);
  });

  var setCalendarViewProperty = function(calendar, modelId) {
    // カレンダの日付表示フォーマットを変更する
    calendar.columnView.set('columnHeaderDatePattern', 'MM/dd'); // 週表示時のヘッダ(日付)
    calendar.matrixView.set('columnHeaderLabelLength', 'short'); // 月表示時のヘッダ(曜日)
    calendar.matrixView.set('cellHeaderShortPattern', 'dd');     // 月表示時の日付(当月)表示
    calendar.matrixView.set('cellHeaderLongPattern', 'MM/dd');   // 月表示時の日付(月替わり日)表示
    calendar.matrixView.set('scrollable', true);                 // 月表示時はスクロール可能

    // 画面に合わせてカレンダの表示サイズを変更する
    setCalendarSize(calendar);

    // 画面の向きを変えた際にカレンダの表示サイズを変更する
    on(window, "orientationchange", function(e) {
      setCalendarSize(calendar);
    });
  }

  var setCalendarSize = function(calendar) {
    var windowSize = win.getBox();
    var calendarWidth = windowSize.w;
    var calendarHeight = windowSize.h - 30;
    calendar.resize({w:calendarWidth, h:calendarHeight})
  }

  // カレンダビューデータ検索関数
  var searchCalendarItemFunc;

  var setCalendarviewEvent = function(calendar) {
    // 登録ボタンのイベントを設定
    setToolBarBtnNewEvent(calendar);
    // カレンダビューのトランジッションイベントを設定
    setCalendarviewTransitionEvent(calendar);
    // 検索条件値変更時にフラグをセットする処理を設定
    setConditionWidgetsOnChangeEvent();
    // カレンダビューデータ検索関数を取得する
    searchCalendarItemFunc = ModernCalendarUtil.getConditionWidgetChangeEventFunc(calendar);
  }

  var setRegisterCalendarItemOverlay = function(calendarOption, calendar) {
    // モデル選択リストボックス選択肢を設定
    ModernCalendarUtil.setCalendarViewModelData(calendarOption, true);
    // 新規登録ダイアログ入力欄のイベント設定
    setRegisterCalendarItemEvent(calendar);
    // 新規登録ダイアログのラベル設定
    setRegisterCalendarItemLables();
  }

  var setRegisterCalendarItemEvent = function(calendar) {
    // 終日チェックボックス押下イベント
	ModernCalendarUtil.setJfcCalendarItemAllDayEvent(jfcRegisterMobileCalendarItemAllDay);
    // 新規登録画面表示ボタン押下イベント
    btnInsertJfcRegisterMobileCalendarItem.on('click', function() {
      ModernCalendarUtil.insertCalendarItemFromForm(calendar);
    });
  }

  var setRegisterCalendarItemLables = function() {
    var labels = [
      res.LABEL_CALENDAR_DIALOG_MODELNAME,
      res.LABEL_CALENDAR_DIALOG_TITLE,
      res.LABEL_CALENDAR_DIALOG_STARTDATETIME,
      res.LABEL_CALENDAR_DIALOG_ENDDATETIME,
      res.LABEL_CALENDAR_DIALOG_ALLDAYFLAG
    ];
    query("h1", "jfcRegisterCalendarItemOverlay").forEach(function(node) {
      domProp.set(node, "innerHTML", res.LABEL_CALENDAR_NEW_REGISTRATION);
    });
    query("th", "jfcRegisterMobileCalendarItemForm").forEach(function(node, i) {
      domProp.set(node, "innerHTML", labels[i]);
    });
    btnInsertJfcRegisterMobileCalendarItem.set("label", res.LABEL_CALENDAR_DIALOG_BTN_INSERT);
    btnCancelJfcRegisterMobileCalendarItem.set("label", res.BUTTON_CANCEL);
  }

  var setDateValueToRegisterCalendarItem = function(calendar) {
    var registerDate;
    var event = ModernCalendarUtil.selectedDateEvent;
    if (event) {
      registerDate = event.date;
    } else {
      registerDate = calendar.get("date");
    }
    if (!registerDate) {
      return;
    }
    var txtRegisterDate = _setDateWithFormat(registerDate, "yyyy-MM-dd");
    // 開始日
    jfcRegisterMobileCalendarItemStartDate.set("value", txtRegisterDate);
    // 終了日
    jfcRegisterMobileCalendarItemEndDate.set("value", txtRegisterDate);
    // 開始時刻
    jfcRegisterMobileCalendarItemStartTime.set("value", "T09:00");
    // 終了時刻
    jfcRegisterMobileCalendarItemEndTime.set("value", "T18:00");
  }

  var setToolBarBtnNewEvent = function(calendar) {
    var toolBarBtnNew = registry.byId('jfcToolBarBtnNew');
    if (!toolBarBtnNew) {
      return;
    }
    toolBarBtnNew.on('click', function() {
      registry.byId('jfcRegisterCalendarItemOverlay').show();
      setDateValueToRegisterCalendarItem(calendar);
    });
  }

  var setCalendarviewTransitionEvent = function(calendar) {
    var showListView = registry.byId('showList');
    // カレンダビュー表示前のイベント
    connect.connect(showListView, "onBeforeTransitionIn", null,
      function(moveTo, dir, transition, context, method) {
        // 検索条件の変更イベントを待って、カレンダビューのデータを検索表示する
        setTimeout(function() {
          showCalendarItem(calendar);
        }, 10);
      }
    );
    // カレンダビュー表示後のイベント
    connect.connect(showListView, "onAfterTransitionIn", null,
      function(moveTo, dir, transition, context, method) {
        // 検索条件変更フラグをクリアする
        clearConditionValueChanged();
      }
    );
  }

  var changeToolBarBtnSearchProperties = function(moveTo) {
    var toolBarBtnSearch = registry.byId('jfcToolBarBtnSearch');
    if (!toolBarBtnSearch) {
      return;
    }
    var moveNext = "showList";
    var transitionDir = 1;
    if (moveTo !== "condition") {
      moveNext = "condition";
      transitionDir = -1;
    }
    toolBarBtnSearch.set("moveTo", moveNext);
    toolBarBtnSearch.set("transitionDir", transitionDir);
  }

  var conditionValueChanged = {};
  var setConditionWidgetsOnChangeEvent = function() {
    // 検索条件の入力欄を取得する
    getConditionWidgetsInTab();
    for (var tabId in conditionWidgetsInTab) {
      var conditionInTab = conditionWidgetsInTab[tabId];
      if (!conditionInTab) {
        continue;
      }
      var conditionWidgets = conditionInTab.conditionWidgets;
      if (!conditionWidgets || conditionWidgets.length === 0) {
        continue;
      }
      // 検索条件を変更した際に変更フラグをセットする
      for (var i=0,l=conditionWidgets.length; i<l; i++) {
        var conditionWidget = conditionWidgets[i];
        setOnChangeEventToConditionWidget(tabId, conditionWidget);
      }
    }
  }

  var setOnChangeEventToConditionWidget = function(tabId, conditionWidget) {
    conditionWidget.on("change", function(value) {
      conditionValueChanged[tabId] = true;
    });
  }

  var showCalendarItem = function(calendar) {
    for (var tabId in conditionValueChanged) {
      if (!conditionValueChanged[tabId]) {
        continue;
      }
      var conditionInTab = conditionWidgetsInTab[tabId];
      if (!conditionInTab) {
        continue;
      }
      var modelId = conditionInTab.modelId;
      var conditionWidgets = conditionInTab.conditionWidgets;
      if (!modelId || !conditionWidgets || conditionWidgets.length === 0) {
        continue;
      }
      searchCalendarItemFunc(modelId, calendar.get("date"), getSearchCondition(conditionWidgets));
    }
  }

  var clearConditionValueChanged = function() {
    for (var tabId in conditionValueChanged) {
      conditionValueChanged[tabId] = false;
    }
  }

  var conditionWidgetsInTab = {};
  var getConditionWidgetsInTab = function() {
    var tabContainer = registry.byId("calendarConditionTabContainer");
    if (!tabContainer) {
      return;
    }
    var tabs = tabContainer.getChildren();
    if (!tabs || tabs.length === 0) {
      return;
    }
    for (var i=0,l=tabs.length; i<l; i++) {
      var tab = tabs[i];
      var conditionForms = query("form", tab.domNode);
      if (!conditionForms || conditionForms.length === 0) {
        continue;
      }
      var conditionForm = conditionForms[0];
      var conditionWidgets = registry.findWidgets(conditionForm);
      conditionWidgets = array.filter(conditionWidgets, function(widget) {
        // ボタン以外の入力フォームを返す
        return widget.type !== 'button' && widget.id.lastIndexOf('btnClear', 0) !== 0;
      });
      if (conditionWidgets.length === 0) {
        continue;
      }
      var modelId = getModelIdFromWidgetId(conditionWidgets);
      if (!modelId) {
        continue;
      }
      // タブID毎に検索対象モデルID、検索条件入力欄を保持しておく
      conditionWidgetsInTab[tab.id] = {
        modelId: modelId,
        conditionWidgets: conditionWidgets
      };
    }
  }

  // フォームの入力欄から modelId を取得する
  var modelIdRegexp = new RegExp("^(\\w+)_cp.*$");
  var getModelIdFromWidgetId = function(conditionWidgets) {
    for (var i=0; i<conditionWidgets.length; i++) {
      var conditionWidget = conditionWidgets[i];
      var id = conditionWidget.id;
      if (!id || id === "") {
        continue;
      }
      modelId = (modelIdRegexp.exec(id) || [])[1] || null;
      if (modelId) {
        return modelId;
      }
    }
    return null;
  }

  var getWidgetValue = function(widget) {
    var value;
    if (widget.baseClass.indexOf('dijitDateTextBox') !== -1 ||
          widget.declaredClass === 'dijit.form.FilteringSelectEx') {
      value = widget.get('displayedValue');
    } else {
      value = widget.get('value');
    }
    if (value !== value) {
      value = '';
    }
    return value || '';
  }

  // フォームから検索条件を取得する
  var getSearchCondition = function(conditionWidgets) {
    var condition = {};
    condition['action_Search_Condition'] = '';
    for (var i=0,l=conditionWidgets.length; i<l; i++) {
      var widget = conditionWidgets[i];
      var key = widget.id;
      if (widget.baseClass.indexOf('dijitRadio') !== -1) {
        if (!widget.get('checked')) {
          continue;
        }
        key = widget.name;
      }
      condition[key] = getWidgetValue(widget);
    }
    condition['action_Search_Condition'] = '';
    return condition;
  }

  var disableJspMessageAndBubble = function() {
    var message = "";
    query("div[class='infomsg']").forEach(function(msg) {
      message += (msg.innerHTML + "<br>");
      domStyle.set(msg, "display", "none");
    });
    jfcBubble.info(message);

    message = "";
    query("div[class='errormsg']").forEach(function(msg) {
      message += (msg.innerHTML + "<br>");
      domStyle.set(msg, "display", "none");
    });
    jfcBubble.error(message);
  }
});
</script>
